#!/bin/sh
# paves2.sh # Quatre ou cinq fentres en pavs.
# Utilise : / Uses: wmctrl, awk, wc
#   Christian L'cuyer, Gatineau (Qc), Canada, 1er sept. 2017. GPL3
#  (alias musher0 [forum Puppy]) # https://opensource.org/licenses/GPL-3.0
#################### # Rev. : 14 janv. 2018.
#    This program is free software: you can redistribute it and/or modify it under the
#    terms of the GNU General Public License as published by the Free Software Foundation,
#    either version 3 of the License, or  (at your option) any later version.
#    	This program is distributed in the hope that it will be useful, but WITHOUT ANY
#    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
#    A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#    	You should have received a copy of the GNU General Public License along with
#   this program. If not, see <http://www.gnu.org/licenses/>.
##########
#   Ce programme est libre : vous pouvez le redistribuer ou modifier selon les termes
#   de la Licence Publique Gnrale GNU publie par la Free Software Foundation (v. 3
#   ou toute version ultrieure choisie par vous).
#       Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
#   GARANTIE, ni explicite ni implicite, y compris des garanties de commercialisation
#   ou d'adaptation  un but spcifique. Pour plus de dtails, veuillez vous reporter
#   au texte officiel de cette licence  https://opensource.org/licenses/GPL-3.0, 
#   http://www.linux-france.org/article/these/gpl.html pour une traduction et, pour une
#   explication en franais,  https://fr.wikipedia.org/wiki/Licence_publique_gnrale_GNU.
#################### set -xe
Bur="`wmctrl -d | awk '$2 ~/\*/ { print $1 }'`"
wmctrl -l | awk '$2 ~ /'"$Bur"'/ && $4 !~ /Conky|stalonetray|jar|exe|xclock|xload|N\/A/ { print $1 }' > /tmp/fen
# Ne pas utiliser sur une fentre contrle par java, DOSBOX ou Wine, ou par Conky.
# On passe aussi xclock et xload.
# Mais si le titre de la fentre de xclock n'est pas  clock , elle sera affecte.

awk '0 == NR % 2' /tmp/fen > /tmp/fen-paires # even lines
awk '0 == NR % 2' /tmp/fen-paires > /tmp/fen-paires-bas
awk '0 == (NR + 1) % 2' /tmp/fen-paires > /tmp/fen-paires-haut

awk '0 == (NR + 1) % 2' /tmp/fen > /tmp/fen-impaires # odd lines
awk '0 == NR % 2' /tmp/fen-impaires > /tmp/fen-impaires-bas
awk '0 == (NR + 1) % 2' /tmp/fen-impaires > /tmp/fen-impaires-haut

DemiHauteur="`xwininfo -root | awk '$1 ~ /Height/ { print $2/2 }'`" # Half height of screen
DemiLargeur="`xwininfo -root | awk '$1 ~ /Width/ { print $2/2 }'`" # Half width of screen

PositioN () { Valid="";Valid="`wc -l < $file`";
if [ "$Valid" -gt "0" ];then
	K="$A";L="$B"
	line="";while read line;do
		wmctrl -i -r $line -e 0,$K,$L,0,0 2>/dev/null &
		L="`expr $L + 100`"
	done < $file
fi; }

Bas () { B="";B="$DemiHauteur";PositioN; }

file="";file=/tmp/fen-paires-haut
A="";A=32
B="";B=32
PositioN

file="";file=/tmp/fen-paires-bas
Bas

file="";file=/tmp/fen-impaires-haut
A="";A="$DemiLargeur"
B="";B=32
PositioN

file="";file=/tmp/fen-impaires-bas
Bas

rm -f /tmp/fen* # Nettoyage | Cleanup # set +xe
